Package net.dona.doip.server

# Interface DoipServerRequest

All Known Implementing Classes:
  `DoipServerRequestImpl`

public interface DoipServerRequest
Interface for an incoming DOIP request to be handled by a `DoipProcessor`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `com.google.gson.JsonElement`
  `getAttribute(String key)`
  Returns a single attribute from the attributes given by the initial segment of the DOIP request.
  `String`
  `getAttributeAsString(String key)`
  Returns as a String a single attribute from the attributes given by the initial segment of this DOIP request.
  `com.google.gson.JsonObject`
  `getAttributes()`
  Returns the attributes given by the initial segment of this DOIP request.
  `com.google.gson.JsonElement`
  `getAuthentication()`
  Returns the authentication information given by the initial segment of this DOIP request.
  `String`
  `getClientId()`
  Returns the client ID given by the initial segment of this DOIP request.
  `X509Certificate[]`
  `getConnectionCertificateChain()`
  If the client is using a TLS client-side certificate, this returns the supplied certificate chain.
  `String`
  `getConnectionClientId()`
  If the client is using a TLS client-side certificate, this returns the client id from the certificate.
  `PublicKey`
  `getConnectionPublicKey()`
  If the client is using a TLS client-side certificate, this returns the public key from the certificate.
  `InDoipMessage`
  `getInput()`
  Returns the input of the request.
  `String`
  `getOperationId()`
  Returns the operation ID (the operation to perform) given by the initial segment of this DOIP request.
  `String`
  `getTargetId()`
  Returns the target ID (the object on which to perform the operation) given by the initial segment of this DOIP request.

- ## Method Details

  - ### getClientId

    String getClientId()
    Returns the client ID given by the initial segment of this DOIP request.
    Returns:
      the client ID given by the initial segment of this DOIP request

  - ### getTargetId

    String getTargetId()
    Returns the target ID (the object on which to perform the operation) given by the initial segment of this DOIP request.
    Returns:
      the target ID given by the initial segment of this DOIP request

  - ### getOperationId

    String getOperationId()
    Returns the operation ID (the operation to perform) given by the initial segment of this DOIP request.
    Returns:
      the operation ID given by the initial segment of this DOIP request

  - ### getAttributes

    com.google.gson.JsonObject getAttributes()
    Returns the attributes given by the initial segment of this DOIP request.
    Returns:
      the attributes given by the initial segment of this DOIP request

  - ### getAttribute

    com.google.gson.JsonElement getAttribute(String key)
    Returns a single attribute from the attributes given by the initial segment of the DOIP request.
    Parameters:
      `key` - the attribute to retrieve
    Returns:
      a single attribute from the attributes given by the initial segment of the DOIP request

  - ### getAttributeAsString

    String getAttributeAsString(String key)
    Returns as a String a single attribute from the attributes given by the initial segment of this DOIP request.
    Parameters:
      `key` - the attribute to retrieve
    Returns:
      a single attribute as a string from the attributes given by the initial segment of this DOIP request

  - ### getAuthentication

    com.google.gson.JsonElement getAuthentication()
    Returns the authentication information given by the initial segment of this DOIP request.
    Returns:
      the authentication information given by the initial segment of this DOIP request

  - ### getInput

    InDoipMessage getInput()
    Returns the input of the request. In the case of a "compact" single-segment request, this will be a single JSON segment corresponding to the "input" property of the single-segment request. Otherwise it will be all remaining segments of the request after the initial segment.
    Returns:
      the input of this DOIP request

  - ### getConnectionClientId

    String getConnectionClientId()
    If the client is using a TLS client-side certificate, this returns the client id from the certificate.
    Returns:
      the client ID from a TLS client-side certificate

  - ### getConnectionPublicKey

    PublicKey getConnectionPublicKey()
    If the client is using a TLS client-side certificate, this returns the public key from the certificate.
    Returns:
      the public key from a TLS client-side certificate

  - ### getConnectionCertificateChain

    X509Certificate[] getConnectionCertificateChain()
    If the client is using a TLS client-side certificate, this returns the supplied certificate chain.
    Returns:
      the supplied certificate chain from a a TLS client-side certificate